; PIC-Assembler-Listing by s.foelz (c)2006,2007
; 14-bit-core

;; Neue Version
; RA0	:< ADC
; RA1	:> LED0
; RA2	:> LED1
; RA3	:> LED2
; RA4	:> X1
; RA5	:< ^MCLR			Vpp
; RA6	:> X2
; RA7	:> X3

; RB0	:< KEY0				(no INT)
; RB1	:< KEY1
; RB2	:< KEY2
; RB3	:< KEY-Shift				
; RB4	:< LN-RX
; RB5	:> LN-TX
; RB6	:< VOR				CLK
; RB7	:< RUECK			DATA

; Marke  Mnemonic  
; ================================

	LIST	P=PIC16F819

#include	P16F819.INC

; Konfiguration
	__config	0x3F30
;	org 	0x2007
;	DA  	0x3F30
	errorlevel 2

RAM 		EQU	0x20
speed		EQU	RAM			;	Slot Speed 0...0x7F
dirf		EQU	RAM+0x01	;	Slot DIRF	F0-4 state
snd 		EQU	RAM+0x02	;	Slot Sound
slot		EQU	RAM+0x03	;	Slot Number
stat		EQU	RAM+0x04	;	Slot Status
ss2 		EQU	RAM+0x05	;	SS2		Slot Status2
adr2		EQU	RAM+0x06	;	ADR2	Slot Loco Adr High
adr_		EQU	RAM+0x07	;	ADR
id1 		EQU	RAM+0x08	;	ID1		DeviceID1
id2 		EQU	RAM+0x09	;	ID2		DeviceID2
trk 		EQU	RAM+0x0A	;	TRK
input		EQU	RAM+0x0B	;	Schattenregister PortB
flags		EQU	RAM+0x0C	;	Flags zur allg. Steuerung
led0		EQU	RAM+0x0D	;	LEDs F0-2
led1		EQU	RAM+0x0E	;	LEDs F3,4
led2		EQU	RAM+0x0F	;	LEDs Vor, Status und Rck 
z_timer		EQU	RAM+0x10	;	Timer fr Richtung
key_0		EQU	RAM+0x11	;	Tasten F0-F4, Vor, Status und Rck 
setLED		EQU	RAM+0x12	;	Tasten F4, Set und Stop
t_count		EQU	RAM+0x13	;	
s_key		EQU	RAM+0x14	;	Statusflags fr Key
time_sl		EQU	RAM+0x15	;	0,5ms Timer
time_sh		EQU	RAM+0x16	;	0,128s Timer
ser_io		EQU	RAM+0x17	;	ser. Eingabe
temp_ser	EQU	RAM+0x18	;	Temp-Register fr Ser. bertragung
checksum	EQU	RAM+0x19	;	LocoNet checksum
xor_io		EQU	RAM+0x1A	;	ser. XOR io
s_ser		EQU	RAM+0x1B	;	Status ser. Steuerung
s_count		EQU	RAM+0x1C	;	Anzahl Sendeversuche
t_speed		EQU	RAM+0x1D	;	Schattenregister fr speed (analog)
t_dirf		EQU	RAM+0x1E	;	Schattenregister fr dirf
t_snd		EQU	RAM+0x1F	;	Schattenregister fr snd
slotd		EQU	RAM+0x20	;	Destination Slot Number
byte0		EQU	RAM+0x21	;	 2. Byte empfangen
byte1		EQU	RAM+0x22	;	 3. Byte empfangen
byte2		EQU	RAM+0x23	;	 4. Byte empfangen
byte3		EQU	RAM+0x24	;	 5. Byte empfangen
byte4		EQU	RAM+0x25	;	 6. Byte empfangen
byte5		EQU	RAM+0x26	;	 7. Byte empfangen
byte6		EQU	RAM+0x27	;	 8. Byte empfangen
byte7		EQU	RAM+0x28	;	 9. Byte empfangen
byte8		EQU	RAM+0x29	;	10. Byte empfangen
byte9		EQU	RAM+0x2A	;	11. Byte empfangen
byteA		EQU	RAM+0x2B	;	12. Byte empfangen
byteB		EQU	RAM+0x2C	;	13. Byte empfangen
byteC		EQU	RAM+0x2D	;	14. Byte empfangen
byteD		EQU	RAM+0x2E	;	15. Byte empfangen
byteE		EQU	RAM+0x2F	;	16. Byte empfangen
byteF		EQU	RAM+0x30	;	17. Byte empfangen
lncvs		EQU	RAM+0x31	;	
lncvd		EQU	RAM+0x32	;
lndhi		EQU	RAM+0x33	;
lnim1		EQU	RAM+0x34	;
lnim2		EQU	RAM+0x35	;
lnim3		EQU	RAM+0x36	;
lnim4		EQU	RAM+0x37	;
lnim5		EQU	RAM+0x38	;
lnim6		EQU	RAM+0x39	;
versionl	EQU	RAM+0x3A	;
versionh	EQU	RAM+0x3B	;
lack1		EQU	RAM+0x3C	;	Antwort fr LACK
lack2		EQU	RAM+0x3D	;	Antwort fr LACK
command		EQU	RAM+0x3E	;	LocoNet Commando
speed1  	EQU	RAM+0x3F	;	Register fr Analog
speed2  	EQU	RAM+0x40	;	Register fr Analog
speed3  	EQU	RAM+0x41	;	Register fr Analog


;   		EQU	0x70    	;	wichtige Register
;   		... 			;	...
;   		EQU	0x7B		;
z_wait     	EQU	0x7C		;	Timerwert fr Richtungswechsel	
ee_byte		EQU	0x7D		;	EEPROM byte
temp_w		EQU	0x7E		;	Schattenregister fr w
temp_stat	EQU	0x7F		;	   -- " --       fr Status

EEPROM		EQU	0x00
EE_adr_		EQU	EEPROM+0x00	;	adr_
EE_adr2		EQU	EEPROM+0x01	;	adr2
EE_speed	EQU	EEPROM+0x02	;	speed
EE_dirf		EQU	EEPROM+0x03	;	dirf
EE_snd		EQU	EEPROM+0x04	;	snd
EE_idL		EQU	EEPROM+0x05	;	FRED-ID Low
EE_idH		EQU	EEPROM+0x06	;	FRED-ID High
EE_verL		EQU	EEPROM+0x07	;	Version Low
EE_verH		EQU	EEPROM+0x08	;	Version High
EE_z_wait	EQU	EEPROM+0x09	;	z_wait
EE_analog	EQU	EEPROM+0x0A	;	Analog
EE_wstrom	EQU	EEPROM+0x0B	;	Wechselstrommodus
EE_lock		EQU	EEPROM+0x0C	;	sperre Lokadresse
;EE_r0C		EQU	EEPROM+0x0D


; ********************** Programm Start **************************
	ORG 	0x0000
START
	CALL	INIT
	CALL	INIT2
	GOTO	MAIN

; ************************ Interrupt *****************************
	ORG 	0x0004
INT
	MOVWF	temp_w
	SWAPF	STATUS,w
	MOVWF	temp_stat
	CLRF	STATUS

	MOVFW	PORTB
	MOVWF	input
	BTFSS	input,4
	GOTO	INT_LN
	BTFSC	flags,5			;	berspringen im Analog-Modus
	GOTO	LED_AUSGABE_I
	BCF 	s_key,2

	BTFSS	dirf,5
	GOTO	VORWAERTS
	BTFSC	flags,6			;	Vorwrts im Gleichstrommodus
	GOTO	VORWAERTS
	BTFSS	input,6
	GOTO	SPEED_DOWN
	BTFSS	input,7
	GOTO	SPEED_UP
	GOTO	LED_AUSGABE_I

VORWAERTS
	BTFSS	input,7
	GOTO	SPEED_DOWN
	BTFSS	input,6
	GOTO	SPEED_UP
	GOTO	LED_AUSGABE_I

SPEED_UP
	MOVLW	0x7F
	XORWF	speed,0
	BTFSS	STATUS,Z
	INCF	speed,1
	BCF 	time_sh,7
	BSF 	s_key,3
	MOVLW	0x01
	XORWF	speed,0
	BTFSC	STATUS,Z
	INCF	speed,1
	GOTO	LED_AUSGABE_I

SPEED_DOWN
	MOVLW	0x00
	XORWF	speed,0
	BTFSS	STATUS,Z		;	Richtungswechsel bei 0
	GOTO	SPEED_DOWN3
	BTFSC	flags,6
	GOTO	SPEED_DOWN2
	MOVF	z_timer,1
	BTFSS	STATUS,Z
	GOTO	SPEED_DOWN2
	MOVLW	B'00100000'
	XORWF	t_dirf,1
	BCF 	time_sh,7
SPEED_DOWN2
	MOVFW	z_wait
	MOVWF	z_timer
	GOTO	LED_AUSGABE_I
SPEED_DOWN3
	DECF	speed,1
	BCF 	time_sh,7
	MOVF	slot,1
	BTFSS	STATUS,Z
	BSF 	s_key,3
	MOVFW	z_wait
	MOVWF	z_timer
;	GOTO	LED_AUSGABE_I

LED_AUSGABE_I				;	LED-Ausgabe bis Drehregler wieder rastet
	MOVLW	0x34
	CALL	WARTE10t_p

	MOVFW	setLED
	BTFSC	STATUS,Z
	GOTO	LED_AUSGABE1_I
	BTFSC	setLED,0
	GOTO	LED_AUSGABE2_I
	GOTO	LED_AUSGABE3_I

LED_AUSGABE1_I
	MOVFW	led0
	MOVWF	PORTA
	INCF	setLED
	GOTO	LED_AUSGABE4_I

LED_AUSGABE2_I
	MOVFW	led1
	MOVWF	PORTA
	INCF	setLED
	GOTO	LED_AUSGABE4_I

LED_AUSGABE3_I
	MOVFW	led2
	MOVWF	PORTA
	CLRF	setLED

LED_AUSGABE4_I
	MOVFW	PORTB
	ANDLW	0xC0
	XORLW	0xC0
	BTFSS	STATUS,Z
	GOTO	LED_AUSGABE_I
	GOTO	INT_ENDE

INT_LN						;	empfange Daten ber LN
	MOVLW	0x07			;	14t / 7
	CALL	WARTE10t_p		;	11/13/17 s (9*2+3)
;	CLRF	s_ser			;	x
;	BSF 	s_ser,4
;	BCF 	s_ser,5
	BCF 	s_ser,7
	MOVLW	0xFF
	MOVWF	xor_io			;	24/24,5 s seit INT

	CALL	LN_READ_BYTE_A	;	lese 1. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	command
	BTFSC	command,6
	GOTO	INT_LN1
	XORLW	0xB4			;	Code B4?
	BTFSC	STATUS,Z
	GOTO	READ_LACK		;	B4 / lese weitere 3 Bytes
	XORLW	0x16			;	Code A2?
	BTFSC	STATUS,Z
	GOTO	READ_SND		;	A2 / lese weitere 3 Bytes
	XORLW	0x03			;	Code A1?
	BTFSC	STATUS,Z
	GOTO	READ_DIRF		;	A1 / lese weitere 3 Bytes
	XORLW	0x01			;	Code A0?
	BTFSC	STATUS,Z
	GOTO	READ_SPEED		;	A0 / lese weitere 3 Bytes
	XORLW	0x20			;	Code 81?
	BTFSC	STATUS,Z
	GOTO	READ_NOP		;	81 / NOP
	BSF		s_ser,7
	GOTO	INT_LN_ENDE
INT_LN1
	XORLW	0xED			;	Code ED?
	BTFSC	STATUS,Z
	GOTO	READ_IMM_PACKET	;	ED / lese weitere 11 Bytes
	XORLW	0x0A			;	Code E7?
	BTFSC	STATUS,Z
	GOTO	READ_SLOT_DATA	;	E7 / lese weitere 13 Bytes
	XORLW	0x02			;	Code E5?
	BTFSC	STATUS,Z
	GOTO	READ_PEER_XFER	;	E5 / lese weitere 13 Bytes
	

INT_LN_ENDE
	BCF 	INTCON,INTF
	GOTO	INT_ENDE

INT_ENDE
	BCF 	INTCON,RBIF
	SWAPF	temp_stat,w
	MOVWF	STATUS
	SWAPF	temp_w,f
	SWAPF	temp_w,w
	RETFIE					;	Interrupt Ende

; ************** Empfange bytes INT **************************

READ_IMM_PACKET				;	ED / lese weitere n Byte
	BCF 	s_ser,1
READ_PEER_XFER_1			;	E5 / lese weitere n Byte
	CALL	LN_READ_BYTE	;	lese 2. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	SUBLW	0x0F
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 5. Byte 
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte2
	CALL	LN_READ_BYTE	;	lese 6. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte3
	CALL	LN_READ_BYTE	;	lese 7. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte4
	CALL	LN_READ_BYTE	;	lese 8. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte5
	CALL	LN_READ_BYTE	;	lese 9. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte6
	CALL	LN_READ_BYTE	;	lese 10. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte7
	CALL	LN_READ_BYTE	;	lese 11. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte8
	CALL	LN_READ_BYTE	;	lese 12. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte9
	CALL	LN_READ_BYTE	;	lese 13. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byteA
	CALL	LN_READ_BYTE	;	lese 14. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byteB
	CALL	LN_READ_BYTE	;	lese 15. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE

;0	01h
;1	05h
;2	00h
;3	command 21h Read(E5) / 20h Write(B4)
;4	DHI
;5	IM1						;	Modulkennung 44Ch
;6	IM2						;	
;7	IM3						;	Adresse
;8	IM4						;
;9	IM5						;	M-Adresse/Wert
;A	IM6						;
;B	IM7
	BTFSC	byte4,0			;	Bit 7 auflsen
	BSF 	byte5,7
	BTFSC	byte4,1
	BSF 	byte6,7
	BTFSC	byte4,2
	BSF 	byte7,7
	BTFSC	byte4,3
	BSF 	byte8,7
	BTFSC	byte4,4
	BSF 	byte9,7
	BTFSC	byte4,5
	BSF 	byteA,7
	BTFSC	byte4,6
	BSF 	byteB,7

	MOVLW	0x4C			;	Modultyp 11000?
;	MOVLW	0x4D			;	Modultyp 11010? als Alternative
	XORWF	byte5;0
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVLW	0x04
	XORWF	byte6;0
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE

	BTFSS	s_ser,2
	GOTO	LNCV_START

	BTFSC	s_ser,1
	GOTO	LNCV_END

	MOVLW	0x21
	XORWF	byte3,0
	BTFSC	STATUS,Z
	GOTO	LNCV_READ
	MOVLW	0x20
	XORWF	byte3,0
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE
	GOTO	INT_LN_ENDE

READ_SLOT_DATA				;	E7 / lese weitere 13 Byte
	BTFSS	flags,2
	GOTO	INT_LN_ENDE
	CALL	LN_READ_BYTE	;	lese 2. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	SUBLW	0x0E
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 5. Byte 
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte2
	CALL	LN_READ_BYTE	;	lese 6. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte3
	CALL	LN_READ_BYTE	;	lese 7. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte4
	CALL	LN_READ_BYTE	;	lese 8. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte5
	CALL	LN_READ_BYTE	;	lese 9. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte6
	CALL	LN_READ_BYTE	;	lese 10. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte7
	CALL	LN_READ_BYTE	;	lese 11. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte8
	CALL	LN_READ_BYTE	;	lese 12. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte9
	CALL	LN_READ_BYTE	;	lese 13. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byteA
	CALL	LN_READ_BYTE	;	lese 14. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE

;0	slot
;1	stat
;2	adr_
;3	speed
;4	dirf
;5	trk
;6	ss2
;7	adr2
;8	snd
;9	id1
;A	id2
;	adr_ und adr2 vergleichen wenn ungleich 0!
	BTFSS	flags,0
	GOTO	READ_SLOT_DATA_A
	MOVFW	adr2
	XORWF	byte7,0
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	adr_
	XORWF	byte2,0
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE

READ_SLOT_DATA_A
	MOVFW	byte2
	MOVWF	adr_
	MOVFW	byte7
	MOVWF	adr2

	MOVFW	byte5
	MOVWF	trk
	MOVFW	byte6
	MOVWF	ss2
	MOVFW	byte1
	MOVWF	stat
	MOVFW	byte0
	MOVWF	slot
	MOVFW	byte3
	MOVWF	speed
	MOVFW	byte4
	MOVWF	dirf
	MOVWF	t_dirf
	MOVFW	byte8
	MOVWF	snd
	MOVWF	t_snd

	BSF 	flags,0
	BSF 	flags,1
	BCF 	flags,2
	BSF 	s_ser,5
	BSF 	s_ser,4
;	BSF 	s_ser,3
	GOTO	INT_LN_ENDE

READ_PEER_XFER				;	E5 / lese weitere n Byte
	BSF 	s_ser,1
	BTFSC	s_ser,2
	GOTO	READ_PEER_XFER_1
	GOTO	INT_LN_ENDE

READ_LACK					;	B4 / lese weitere 3 Bytes LACK
	BTFSS	flags,2			;	wird nur auf Existenz geprft!
	GOTO	INT_LN_ENDE		;	kann in spterer Version augewertet werden.
	CALL	LN_READ_BYTE	;	lese 2. Byte Antwort auf Befehl (-0x80)
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	BCF 	flags,2
	BSF 	s_ser,5
	BSF 	s_ser,3
	GOTO	INT_LN_ENDE

READ_SND					;	A2 / lese weitere 3 Bytes
	CALL	LN_READ_BYTE	;	lese 2. Byte
	BTFSC	s_ser,7			;	aktualisiere snd-Byte
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	slot
	XORWF	byte0,w
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	byte1
	MOVWF	snd
	MOVWF	t_snd
	GOTO	INT_LN_ENDE

READ_DIRF					;	A1 / lese weitere 3 Bytes
	CALL	LN_READ_BYTE	;	lese 2. Byte
	BTFSC	s_ser,7			;	aktualisiere dirf-Byte
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	slot
	XORWF	byte0,w
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	byte1
	MOVWF	dirf
	MOVWF	t_dirf
	GOTO	INT_LN_ENDE

READ_SPEED					;	A0 / lese weitere 3 Bytes
	CALL	LN_READ_BYTE	;	lese 2. Byte
	BTFSC	s_ser,7			;	aktualisiere speed
	GOTO	INT_LN_ENDE
	MOVWF	byte0
	CALL	LN_READ_BYTE	;	lese 3. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVWF	byte1
	CALL	LN_READ_BYTE	;	lese 4. Byte
	BTFSC	s_ser,7
	GOTO	INT_LN_ENDE
	MOVFW	xor_io
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	MOVFW	slot
	XORWF	byte0,w
	BTFSS	STATUS,Z
	GOTO	INT_LN_ENDE
	BTFSC	flags,5
	GOTO	READ_SPEED_1

	BCF 	s_key,2			;	Digital-Modus
	MOVFW	byte1
	MOVWF	speed
	BTFSS	STATUS,Z
	BSF 	s_key,3
	GOTO	INT_LN_ENDE

READ_SPEED_1
	MOVFW	byte1			;	Analog-Modus
	XORWF	speed,0
	BTFSS	STATUS,Z
	BSF 	s_key,2			;	Nothalt
	GOTO	INT_LN_ENDE

READ_NOP					;	81 / NOP
;	BSF 	s_ser,5			;	wird ignoriert
;	BCF 	s_ser,3			;	kann ggf. zum verlngern des Timeouts verwndet werden.
	GOTO	INT_LN_ENDE

; ********************** Init PowerOn **************************

INIT						;	PowerOn initialisierung
	CLRF	INTCON
; Clock auf 8 MHz intern
	BSF 	STATUS,RP0
	BSF		OSCCON,IRCF2
	BSF		OSCCON,IRCF1
	BSF		OSCCON,IRCF0
;	BCF 	STATUS,RP0

; Port A konfigurieren AN0 als Analog in
;                      andere als out
;	BSF 	STATUS,RP0
	MOVLW	B'00100001'
	MOVWF	TRISA
	MOVLW	B'00001110'		;	Notwendig bei
 	MOVWF	ADCON1			;	Analog In
; 	BCF 	STATUS,RP0

; Port B konfigurieren RB4 und RB5 fr LocoNet
;                      RB0, RB1, RB2 und RB3 als IN fr Tasten
;                      RB6 und RB7 als in fr Regler
;	BSF 	STATUS,RP0
	MOVLW	B'11011111'
	MOVWF	TRISB
	BCF 	OPTION_REG,NOT_RBPU
	BCF 	OPTION_REG,INTEDG
	BCF 	STATUS,RP0
	CLRF	PORTB			;	Port B zurcksetzen, damit LN frei ist

; ADC konfigurieren
; fr bis 20 Mhz, FOSC/2, AN0, ADON
	MOVLW	B'10000001'
	MOVWF	ADCON0

	BSF 	STATUS,RP0
	BSF 	STATUS,RP1
	BCF 	EECON1,EEPGD
	BCF 	STATUS,RP0
	BCF 	STATUS,RP1

	CLRF	flags			;	allg. Flags lschen

	BSF 	INTCON,GIE
;	BSF 	INTCON,PEIE
	BSF 	INTCON,RBIE

	RETURN

; ********************* Init Teil 2 **************************

INIT2						;	Initialisierung der Konfiguration / Zurcksetzen
	CLRF	setLED

	MOVLW	B'11001110'
	MOVWF	led0
	MOVLW	B'10011110'
	MOVWF	led1
	MOVLW	B'01011110'
	MOVWF	led2
	CALL	LED3_AUSGABE
	CALL	LED3_AUSGABE
	MOVLW	B'11000000'
	MOVWF	led0
	MOVLW	B'10010000'
	MOVWF	led1
	MOVLW	B'11000000'
	MOVWF	led2
	CALL	LED3_AUSGABE
	CALL	LED3_AUSGABE

	MOVLW	B'11000010'
	MOVWF	led0
	CALL	LED3_AUSGABE
	MOVLW	B'11000100'
	MOVWF	led0
	CALL	LED3_AUSGABE
	MOVLW	B'11001000'
	MOVWF	led0
	CALL	LED3_AUSGABE
	MOVLW	B'11000000'
	MOVWF	led0
	MOVLW	B'10010010'
	MOVWF	led1
	CALL	LED3_AUSGABE
	MOVLW	B'10010100'
	MOVWF	led1
	CALL	LED3_AUSGABE
	MOVLW	B'10010000'
	MOVWF	led1
	CALL	LED3_AUSGABE
	CALL	LED3_AUSGABE

; Zurcksetzen und initialisieren fr Test
	CLRF	s_ser
	CLRF	dirf
	CLRF	t_dirf
	CLRF	slot
	CLRF	s_key

; Test ende
	CALL	READ_EEPROM_INIT
	BTFSS	flags,0			;	wenn keine Lokadresse vorhanden
	GOTO	INIT_NOADR		;	in unprogrammierten Zustand gehen.

	CLRF	s_ser
	CLRF	slot

INIT2_A
	BCF 	flags,1
	CALL	SEND_LOCO_ADR	;	REQ Loco ADR
	BTFSC	s_ser,6
	GOTO	INIT2_A			;	neuer Versuch
	CALL	READ_E7			;	Empfang von E7 ...
	BTFSS	s_ser,4
	GOTO	INIT_NOADR		;	kein Slot zugewiesen
INIT2_B
	BCF 	flags,2
	MOVLW	0x33
	MOVWF	stat
	CALL	SEND_WRTIE_SLDATA
	BTFSC	s_ser,6
	GOTO	INIT2_B			;	neuer Versuch
	CALL	READ_E7			;	Empfang von E7 ...
	BTFSS	s_ser,3
	GOTO	INIT_NOADR		;	kein Slot zuweisen
	BCF 	flags,2

INIT_ADR
	MOVLW	B'11001110'
	MOVWF	led0
	MOVLW	B'10010110'
	MOVWF	led1
	CALL	LED3_AUSGABE
	MOVLW	B'11000000'
	MOVWF	led0
	MOVLW	B'10010000'
	MOVWF	led1
	CALL	LED3_AUSGABE

	BTFSS	flags,5
	RETURN
	CALL	LESE_SPEED
	MOVFW	speed
	BTFSS	STATUS,Z
	BSF 	s_key,2			;	Nothalt
	RETURN

INIT_NOADR
	BCF 	flags,0
	BCF 	flags,1
	CLRF	adr_
	CLRF	adr2
	CLRF	dirf
	CLRF	speed
	CLRF	slot
	RETURN

; ********************** Hauptprogramm **************************

MAIN
;	MOVLW	0x04			;	100ms Schleife
;LED_AUSGABE0
	INCF	time_sl,f
	BTFSC	STATUS,Z
	INCF	time_sh,f

	MOVF	z_timer,1
	BTFSC	STATUS,Z
	GOTO	MAIN01
	MOVLW	B'00111111'
	ANDWF	time_sl,0
	BTFSS	STATUS,Z
	GOTO	MAIN01
;	MOVF	time_sl,1
;	BTFSS	STATUS,Z
;	GOTO	MAIN01
	DECF	z_timer

MAIN01
; Setzen der LED-Register led0 und led1
	MOVLW	B'11000000'
	MOVWF	led0
	MOVLW	B'10010000'
	MOVWF	led1
	MOVLW	B'01010000'
	MOVWF	led2

	BTFSC	flags,0			;	Fred ohne Lok
	GOTO	MAIN02
	BTFSS	time_sh,2		;	Blinken 0,4s
	BSF 	led2,2			;	Status / Stop
	CALL	LED_AUSGABE
	GOTO	MAIN11

MAIN02
;	BTFSC	s_key,1
	BTFSS	PORTB,3
	GOTO	MAIN03
	BTFSC	dirf,4			;	F0
	BSF 	led0,1
	BTFSC	dirf,0			;	F1
	BSF 	led0,2
	BTFSC	dirf,1			;	F2
	BSF 	led0,3
	BTFSC	dirf,2			;	F3
	BSF 	led1,1
	BTFSC	dirf,3			;	F4
	BSF 	led1,2
	GOTO	MAIN04

MAIN03						;	Shift (F5-F8)
	BTFSC	snd,0			;	F5
	BSF 	led0,2
	BTFSC	snd,1			;	F6
	BSF 	led0,3
	BTFSC	snd,2			;	F7
	BSF 	led1,1
	BTFSC	snd,3			;	F8
	BSF 	led1,2

MAIN04
	MOVFW	speed
	ANDLW	0xFE
	BTFSC	STATUS,Z
;	GOTO	MAIN05
	BSF 	led2,2			;	Status / Stop

;MAIN05B
	BTFSS	s_key,2
	GOTO	MAIN05
	BTFSS	time_sl,7		;	Blinken 0,2s bei Gegenregeln (Nothalt)
	BSF 	led2,2			;	Status / Stop

;	GOTO	MAIN06
MAIN05
	BTFSS	dirf,5
	BSF 	led2,3			;	vor
	BTFSC	dirf,5
	BSF 	led2,1			;	rueck

MAIN06
	CALL	LED_AUSGABE

;Abfrage der Geschwindigkeit analog
	BTFSS	flags,5
	GOTO	MAIN07	

	MOVF	time_sl,1
	BTFSC	STATUS,Z
	GOTO	MAIN07	
;	BTFSC	time_sh,0

	CALL	LESE_SPEED
;	BTFSS	s_key,2
;	GOTO	MAIN07	
;	CLRF	speed
;	BSF 	s_key,3

MAIN07
;bertragung bei Vernderung
	MOVFW	time_sh			;	bertragung nach timeout
	BTFSS	STATUS,Z
	GOTO	MAIN07A	

	MOVFW	time_sl			;	bertragung nach timeout
	BTFSC	STATUS,Z
	GOTO	MAIN08	

MAIN07A
	MOVFW	speed
	BTFSS	s_key,3
	GOTO	MAIN09
MAIN08
	BTFSS	s_key,2
	CALL	SEND_SPEED		;	bertragung speed
	BCF 	s_key,3

MAIN09
	MOVFW	t_dirf
	XORWF	dirf,w
	BTFSC	STATUS,Z
	GOTO	MAIN10
	MOVFW	t_dirf
	MOVWF	dirf
	CALL	SEND_DIRF		;	bertragung F0-F4 und dir

MAIN10
	MOVFW	t_snd
	XORWF	snd,w
	BTFSC	STATUS,Z
	GOTO	MAIN11
	MOVFW	t_snd
	MOVWF	snd
	CALL	SEND_SND		;	bertragung F5-F8

MAIN11
;	BSF 	INTCON,GIE
;	BTFSS	time_s,4
	GOTO	MAIN

; ***************** Unterprogramme ****************************

READ_EEPROM_INIT			;	read EEPROM init
;	MOVLW	EE_r09
;	CALL	EEPROM_READ
;	MOVWF	r_11
	BCF 	flags,0
	MOVLW	EE_adr_
	CALL	EEPROM_READ
	MOVWF	adr_
	BTFSS	STATUS,Z
	BSF 	flags,0
	MOVLW	EE_adr2
	CALL	EEPROM_READ
	MOVWF	adr2
	BTFSS	STATUS,Z
	BSF 	flags,0
	MOVLW	EE_idL
	CALL	EEPROM_READ
	MOVWF	id1
	MOVLW	EE_idH
	CALL	EEPROM_READ
	MOVWF	id2
	MOVLW	EE_verL
	CALL	EEPROM_READ
	MOVWF	versionl
	MOVLW	EE_verH
	CALL	EEPROM_READ
	MOVWF	versionh
	MOVLW	EE_z_wait
	CALL	EEPROM_READ
	MOVWF	z_wait
	MOVLW	EE_analog
	CALL	EEPROM_READ
	XORLW	0x00
	BTFSS	STATUS,Z
	BSF 	flags,5
	MOVLW	EE_wstrom
	CALL	EEPROM_READ
	XORLW	0x00
	BTFSS	STATUS,Z
	BSF 	flags,6
	MOVLW	EE_lock
	CALL	EEPROM_READ
	XORLW	0x00
	BTFSS	STATUS,Z
	BSF 	flags,4
;	MOVLW	EE_8tasten
;	CALL	EEPROM_READ
;	XORLW	0x00
;	BTFSS	STATUS,Z
;	BSF 	flags,7
	RETURN	

; ************** Sende bytes *****************************

READ_E7						;	Empfang von E7 ...
	BSF 	flags,2
	CLRF	s_ser
READ_ANTWORT
	MOVLW	0xFB			;	250ms bis timeout
;	MOVLW	0x1E
	MOVWF	temp_ser
READ_ANTWORT_1
	MOVLW	0x92
;	MOVLW	0xF7
	CALL	WARTE10t_p		;	497s   (122*2+3)
	BTFSC	s_ser,5
	GOTO	READ_ANTWORT_2
	MOVLW	0x92
;	MOVLW	0xF7
	CALL	WARTE9t_p		;	496,5s (122*2+2,5)
	BTFSC	s_ser,5
	GOTO	READ_ANTWORT_2
	DECFSZ	temp_ser,f
	GOTO	READ_ANTWORT_1
	BSF 	s_ser,7			;	timeout
READ_ANTWORT_2
	RETURN

; ************** Sende bytes *****************************

SEND_WRTIE_SLDATA			;	WRITE SLOT DATA, 10 bytes
	CALL	SET_COUNT		;	0xEF 0x0E [0F] [10] [13] [0C] [0D] [16] [11] [12] [0E] [14] [15] [24]
SEND_WRTIE_SLDATA_1			;	Antwort LACK
	CALL	LOCO_FREE
	MOVLW	0xEF
	CALL	LN_SEND_BYTE
	MOVLW	0x0E
	CALL	LN_SEND_BYTE
	MOVFW	slot
	CALL	LN_SEND_BYTE
	MOVFW	stat
	CALL	LN_SEND_BYTE
	MOVFW	adr_
	CALL	LN_SEND_BYTE
	MOVFW	speed
	CALL	LN_SEND_BYTE
	MOVFW	dirf
	CALL	LN_SEND_BYTE
	MOVFW	trk
	CALL	LN_SEND_BYTE
	MOVFW	ss2
	CALL	LN_SEND_BYTE
	MOVFW	adr2
	CALL	LN_SEND_BYTE
	MOVFW	snd
	CALL	LN_SEND_BYTE
	MOVFW	id1
	CALL	LN_SEND_BYTE
	MOVFW	id2
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_WRTIE_SLDATA_1
	RETURN	

;********************************************************
SEND_PEER_XFER				;	WRITE PEER_XFER, 15 bytes
	CALL	SET_COUNT		;	0xE5 0x0F ...
	CLRF	lndhi
	BTFSC	lnim5,7
	BSF 	lndhi,4
	BTFSC	lnim6,7
	BSF 	lndhi,5
SEND_PEER_XFER_1
	CALL	LOCO_FREE
	MOVLW	0xE5
	CALL	LN_SEND_BYTE
	MOVLW	0x0F
	CALL	LN_SEND_BYTE
	MOVFW	lncvd
	CALL	LN_SEND_BYTE
	MOVLW	0x49
	CALL	LN_SEND_BYTE
	MOVLW	0x4B
	CALL	LN_SEND_BYTE
	MOVLW	0x1F
	CALL	LN_SEND_BYTE
	MOVLW	0x00
;	MOVFW	dhi
	CALL	LN_SEND_BYTE
	MOVLW	0x4C				;	1100 Modul 11000
;	MOVLW	0x4D				;	1101 Modul 11010 als Alternative
;	MOVFW	lnim1
	CALL	LN_SEND_BYTE
	MOVLW	0x04
;	MOVFW	lnim2
	CALL	LN_SEND_BYTE
	MOVFW	lnim3				;	Adresse 0-x
	CALL	LN_SEND_BYTE
	MOVLW	0x00
;	MOVFW	lnim4
	CALL	LN_SEND_BYTE
	MOVFW	lnim5					;	Wert-l / Adresse-l
	CALL	LN_SEND_BYTE
	MOVFW	lnim6					;	Wert-h / Adresse-h
	CALL	LN_SEND_BYTE
	MOVLW	0x00
;	MOVFW	im7
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_PEER_XFER_1
	RETURN	
;********************************************************

SEND_LOCO_ADR				;	REQ Loco ADR
	CALL	SET_COUNT		;	0xBF [12] [13] [24]
SEND_LOCO_ADR_1				;	Antwort E7 ... / LACK
	CALL	LOCO_FREE
	MOVLW	0xBF
	CALL	LN_SEND_BYTE
	MOVFW	adr2
	CALL	LN_SEND_BYTE
	MOVFW	adr_
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_LOCO_ADR_1
	RETURN	

SEND_MOVE_SLOT_GET			;	Get Slot
	CLRF	slot
SEND_MOVE_SLOT_PUT			;	MOVE slot SRC to 0
	CLRF	slotd
SEND_MOVE_SLOT				;	MOVE slot SRC to DEST
	CALL	SET_COUNT		;	0xBA [0F] [0F] [24]
SEND_MOVE_SLOT_1			;	Antwort E7 ... / LACK
	CALL	LOCO_FREE
	MOVLW	0xBA
	CALL	LN_SEND_BYTE
	MOVFW	slot
	CALL	LN_SEND_BYTE
	MOVFW	slotd
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_MOVE_SLOT_1
	RETURN	

SEND_SND					;	SET snd (F5-F8)
	CALL	SET_COUNT		;	0xA2 [0F] [0D] [24]
SEND_SND_1	
	CALL	LOCO_FREE
	MOVLW	0xA2
	CALL	LN_SEND_BYTE
	MOVFW	slot
	CALL	LN_SEND_BYTE
	MOVFW	snd
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_SND_1	
	RETURN

SEND_DIRF					;	SET dirf (F0-F4,dir)
	CALL	SET_COUNT		;	0xA1 [0F] [0D] [24]
SEND_DIRF_1	
	CALL	LOCO_FREE
	MOVLW	0xA1
	CALL	LN_SEND_BYTE
	MOVFW	slot
	CALL	LN_SEND_BYTE
	MOVFW	dirf
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_DIRF_1	
	RETURN

SEND_SPEED					;	SET SLOT speed  
	CALL	SET_COUNT		;	0xA0 [0F] [0C] [24]
SEND_SPEED_1
	CALL	LOCO_FREE
	MOVLW	0xA0
	CALL	LN_SEND_BYTE
	MOVFW	slot
	CALL	LN_SEND_BYTE
	MOVFW	speed
;	BTFSC	s_key,2
;	MOVLW	0x00
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_SPEED_1
	RETURN	

SEND_LACK					;	LACK
	MOVFW	slot
	MOVWF	lack1
	CLRF	lack2
SEND_LACK2					;	LACK fr Programmierung
	CALL	SET_COUNT		;	0xB4 [0x] [00] [xx]
	
SEND_LACK_1
	CALL	LOCO_FREE
	MOVLW	0xB4
	CALL	LN_SEND_BYTE
	MOVFW	lack1
	CALL	LN_SEND_BYTE
	MOVFW	lack2
;	MOVLW	0x00			;	mu fr Programmierungangepasst werden!
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_LACK_1
	RETURN	

;
;SEND_TEST					;	Test, zum debugen
;	CALL	SET_COUNT		;	0xA3 [0F] [0C] [24]
;SEND_TEST_1
;	CALL	LOCO_FREE
;	MOVLW	0xA3
;	CALL	LN_SEND_BYTE
;	MOVFW	slot
;	MOVFW	lncvs
;	MOVFW	byte4
;	CALL	LN_SEND_BYTE
;	MOVFW	lncvd
;	MOVLW	0x00
;	MOVFW	adr_
;	CALL	LN_SEND_BYTE
;	MOVFW	checksum
;	CALL	LN_SEND_BYTE
;	BCF 	INTCON,RBIF
;	BSF 	INTCON,GIE
;	BTFSS	s_ser,6
;	RETURN	
;	DECFSZ	s_count,f
;	GOTO	SEND_TEST_1
;	RETURN	
;

SEND_NOP					;	NOP
	CALL	SET_COUNT		;	0x81 [7E]
SEND_NOP_1
	CALL	LOCO_FREE
	MOVLW	0x81
	CALL	LN_SEND_BYTE
	MOVFW	checksum
	CALL	LN_SEND_BYTE
	BCF 	INTCON,RBIF
	BSF 	INTCON,GIE
	BTFSS	s_ser,6
	RETURN	
	DECFSZ	s_count,f
	GOTO	SEND_NOP_1
	RETURN	

; ******** LN Read **********

LN_READ_BIT					;	(9t) lese ein Bit
	BCF 	STATUS,C
	BTFSC	PORTB,4			;	PORTB[4]	LN-RX = 0?
	BSF 	STATUS,C
	RRF 	ser_io,f
	MOVLW	0x1B
	CALL	WARTE7t_p		;	55,5s (27*2+1,5) (111t)
	RETURN					;	(3/117t)

LN_READ_BYTE				;	lese weiteres Byte
	CLRF	ser_io
LN_READ_BYTE1				;	warte auf Startbit
	BTFSS	PORTB,4			;	PORTB[4]	LN-RX = 1?
	GOTO	LN_READ_BYTE2
	DECFSZ	ser_io,f
	GOTO	LN_READ_BYTE1
	BSF 	s_ser,7
	RETURN
LN_READ_BYTE2
	MOVLW	0x0C
	CALL	WARTE8t_p		;	warte 26s (12*2+2) (+4t)

LN_READ_BYTE_A				; 	lese Byte nach Interrupt
	BTFSS	PORTB,4			;	PORTB[4]	LN-RX = 1?
	GOTO	LN_READ_BYTE3
	MOVLW	0x05
	GOTO	LN_READ_BYTE4
LN_READ_BYTE3
	CLRF	ser_io
	MOVLW	0x1B			;	(7t)
	CALL	WARTE8t_p		;	warte 56,5s (27*2+2,5) (113+7t)
	CALL	LN_READ_BIT		;	60s 1
	CALL	LN_READ_BIT		;	60s 2
	CALL	LN_READ_BIT		;	60s 3
	CALL	LN_READ_BIT		;	60s 4
	CALL	LN_READ_BIT		;	60s 5
	CALL	LN_READ_BIT		;	60s 6
	CALL	LN_READ_BIT		;	60s 7
	CALL	LN_READ_BIT		;	60s 8
	CALL	WARTE4t			;	2s
	CALL	WARTE4t			;	2s
	MOVFW	ser_io
	XORWF	xor_io,f
	BTFSC	PORTB,4			;	PORTB[4]	LN-RX = 0?
	RETURN
LN_READ_BYTE4
	BSF 	s_ser,7
	RETURN

; ********* LN Write ********
SET_COUNT
	BCF 	INTCON,GIE
	MOVLW	0x19
	MOVWF	s_count
	RETURN

LOCO_FREE					;	LocoNet CarrierDetekt
	BTFSS	PORTB,4			;	LN-CX = 1? 
	GOTO	LOCO_FREE
	MOVLW	0x05
	SUBWF	s_count,w
	BTFSS	STATUS,C
	CLRW
	ADDLW	0x09
	MOVWF	ser_io
LOCO_FREE_1
	MOVLW	0x1B
	CALL	WARTE9t_p		;	56,5s (27*2+2,5)	(113t)
	BTFSC	PORTB,4			;	LN-CX = 0?
	GOTO	LOCO_FREE_2
	BSF 	s_ser,6
	RETURN
LOCO_FREE_2
	DECFSZ	ser_io,f
	GOTO	LOCO_FREE_1
	BCF 	s_ser,6
LOCO_FREE_3
	BCF 	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	LOCO_FREE_3
	MOVLW	0xFF
	MOVWF	checksum
	RETURN

LN_SEND_BIT					;	Send LN-Bit
	BCF 	PORTB,5			;	PORTB[5]	LN-TX = 0
	MOVLW	0x0A
	CALL	WARTE9t_p		;	22,5s (10*2+2,5)	(45t)
	MOVLW	0x0A			;	(47t)
LN_SEND_BIT1
	BTFSS	PORTB,4			;	PORTB[4]	LN-RX = 1?
	GOTO	LN_SEND_BIT2
	ADDLW	0xFF
	BTFSS	STATUS,Z
	GOTO	LN_SEND_BIT1	;	(6*9+7t)
	RETURN					;	(3/108t)	
LN_SEND_BIT2				;	Collision!
	BSF 	s_ser,6
	BSF 	PORTB,5			;	PORTB[5]	LN-TX = 1
	MOVLW	0xE0
	CALL	WARTE9t_p		;	0,451ms (224*2+3)	(902t)
	MOVLW	0xE0
	CALL	WARTE7t_p		;	0,450ms (224*2+2)	(900t)
	RETURN

LN_SEND_BYTE				;	Send LN-Byte
	BTFSC	s_ser,6			;	Start-Bit
	GOTO	LN_SEND_BREAK
	BTFSS	PORTB,4			;	PORTB[4]	LN-RX = 1?
	GOTO	LN_SEND_BREAK
	BSF 	PORTB,5			;	PORTB[5]	LN-TX = 1
	MOVWF	ser_io
	XORWF	checksum,f
	MOVLW	0x1A
	CALL	WARTE10t_p		;	55s (26*2+3)	(110t)
	MOVLW	0x08
	MOVWF	temp_ser
LN_SEND_BYTE1
	BTFSS	ser_io,0
	GOTO	LN_SEND_BYTE2	;	(+2t)
	CALL	LN_SEND_BIT		;	(3/108t)
	BTFSS	s_ser,6
	GOTO	LN_SEND_BYTE3
	GOTO	LN_SEND_BREAK
LN_SEND_BYTE2
	NOP
	BSF 	PORTB,5			;	PORTB[5]	LN-TX = 1
	MOVLW	0x1A
	CALL	WARTE10t_p		;	55s (26*2+3)	(110t)
LN_SEND_BYTE3
	RRF 	ser_io,f
	DECFSZ	temp_ser,f
	GOTO	LN_SEND_BYTE1	;	(9t/10t)
	GOTO	LN_SEND_BYTE4
LN_SEND_BYTE4				;	Stop-Bit
	CALL	LN_SEND_BIT		;	(3/108t)
	BTFSC	s_ser,6
	GOTO	LN_SEND_BREAK
	MOVLW	0x01
	CALL	WARTE8t_p		;	3,5s (1*2+1,5)	(7t)	
	BCF 	PORTB,5			;	PORTB[5]	LN-TX = 0
	RETURN
LN_SEND_BREAK				;	Send Abbruch
	BSF 	s_ser,6
	BCF 	PORTB,5			;	PORTB[5]	LN-TX = 0
	RETURN

;************************************************************

LED3_AUSGABE
	MOVLW	0xF4
LED3_AUSGABE0
	MOVWF	t_count
	CALL	LED_AUSGABE
	MOVFW	t_count
	ADDLW	0xFF
	BTFSS	STATUS,Z
	GOTO	LED3_AUSGABE0
	RETURN

LED_AUSGABE
	MOVLW	0x24
	CALL	WARTE10t_p		;	warte 500s (244*2+3,5) (983t+17t)
	MOVLW	0xF4
	CALL	WARTE10t_p		;	warte 500s (244*2+3,5) (983t+17t)

	MOVFW	setLED
	BTFSC	STATUS,Z
	GOTO	LED_AUSGABE1
	BTFSC	setLED,0
	GOTO	LED_AUSGABE2
	GOTO	LED_AUSGABE3

LED_AUSGABE1
	SWAPF	PORTB,0
	IORLW	0x8F
	MOVWF	key_0
	BSF 	STATUS,C
	RLF 	key_0
	MOVFW	led0
	MOVWF	PORTA
	INCF	setLED
	RETURN

LED_AUSGABE2
	MOVFW	PORTB
	IORLW	0xF8
	ANDWF	key_0
	MOVFW	led1
	MOVWF	PORTA
	INCF	setLED
	RETURN

LED_AUSGABE3
	BTFSS	PORTB,0
	BCF 	key_0,3
	BTFSS	PORTB,1
	BCF 	key_0,4
	MOVFW	led2
	MOVWF	PORTA
	CLRF	setLED

	MOVFW	key_0
	XORLW	0xFF
	BTFSS	STATUS,Z		;	Tasten gedrckt?
	GOTO	READ_KEYS1
	BCF 	s_key,0
	RETURN

READ_KEYS1
	BTFSC	s_key,0			;	Tasten schon gedrckt?
	RETURN
	BSF 	s_key,0

	BTFSS	PORTB,3			;	Shift?
	GOTO	READ_KEYS2

	MOVFW	t_dirf
	BTFSS	key_0,0			;	F0
	XORLW	B'00010000'
	BTFSS	key_0,1			;	F1
	XORLW	B'00000001'
	BTFSS	key_0,2			;	F2
	XORLW	B'00000010'
	BTFSS	key_0,3			;	F3	
	XORLW	B'00000100'
	BTFSS	key_0,4			;	F4
	XORLW	B'00001000'
	MOVWF	t_dirf

	BTFSC	key_0,5			;	rck
	GOTO	READ_KEYS1_A
	BSF 	t_dirf,5
	GOTO	READ_KEYS1_D
READ_KEYS1_A
	BTFSC	key_0,6			;	ALPS
	GOTO	READ_KEYS1_C
	MOVF	speed
	BTFSS	STATUS,Z
	GOTO	READ_KEYS1_B
	BTFSS	flags,6
	GOTO	READ_KEYS1_B
	MOVLW	B'00100000'
	XORWF	t_dirf,1		
READ_KEYS1_B
;	CLRF	speed
	GOTO	READ_KEYS1_D
READ_KEYS1_C
	BTFSC	key_0,7			;	vor
	GOTO	READ_KEYS1_F
	BCF 	t_dirf,5
;	GOTO	READ_KEYS1_D
READ_KEYS1_D
	BTFSC	flags,5
	BSF 	s_key,2			;	Nothalt
	BTFSS	flags,5
READ_KEYS1_E
	CLRF	speed			;	Halt
	CALL	SEND_SPEED		;	bertragung speed
READ_KEYS1_F
	RETURN

READ_KEYS2
	BTFSS	key_0,0			;	Dispatching		Shift F0
	GOTO	DISPATCH
	MOVFW	t_snd
	BTFSS	key_0,1			;	F5				Shift F1
	XORLW	B'00000001'
	BTFSS	key_0,2			;	F6				Shift F2
	XORLW	B'00000010'
	BTFSS	key_0,3			;	F7				Shift F3
	XORLW	B'00000100'
	BTFSS	key_0,4			;	F8				Shift F4
	XORLW	B'00001000'
	MOVWF	t_snd

;	MOVFW	flags			;	Test
;	BTFSS	key_0,5			;	Test1			Shift Halt
;	XORLW	B'01000000'		;	zum Test: Umschatung zw. GS- und WS-Modus
;	BTFSS	key_0,7			;	Test2			Shift Halt'
;	XORLW	B'00100000'		;	zum Test: Umschatung zw. analog- und digital-Modus
;	MOVWF	flags			;	Test Ende
	RETURN

DISPATCH
	BTFSC	flags,4
	RETURN

	BTFSC	flags,1
	GOTO	DISPATCH_LEASE
DISPATCH_0
	BCF 	flags,1
	CALL	SEND_MOVE_SLOT_GET	;	MOVE slot SRC to DEST * E7 ...
	BTFSC	s_ser,6
	GOTO	DISPATCH_0		;	neuer Versuch
	CALL	READ_E7			;	Empfang von E7 ...
	BTFSS	s_ser,4
	GOTO	DISPATCH_LEASE	;	kein Slot
DISPATCH_1
	BCF 	flags,2
	MOVLW	0x33
	MOVWF	stat
	CALL	SEND_WRTIE_SLDATA
	BTFSC	s_ser,6
	GOTO	DISPATCH_1		;	neuer Versuch
	CALL	READ_E7			;	Empfang von E7 ...
	BTFSS	s_ser,3
	GOTO	DISPATCH_LEASE	;	kein Slot
	CALL	WRITE_ADR
	BTFSS	flags,5
	GOTO	WRITE_ADR
	CLRF	speed
	BSF 	s_key,2
	BSF 	s_key,3
	GOTO	WRITE_ADR
;	RETURN

DISPATCH_LEASE
	MOVLW	0x23
	MOVWF	stat
	CALL	SEND_WRTIE_SLDATA
	BTFSC	s_ser,6
	GOTO	DISPATCH_LEASE	;	neuer Versuch
	CALL	READ_E7
	CLRF	slot
	CLRF	adr_
	CLRF	adr2
	BCF 	flags,0
	BCF 	flags,1
;	CALL	WRITE_ADR
;	RETURN

WRITE_ADR
	MOVFW	adr_
	MOVWF	ee_byte
	MOVLW	EE_adr_
	CALL	EEPROM_WRITE	;	Write EEPROM EE 0x00 = 0x00
	MOVFW	adr2
	MOVWF	ee_byte
	MOVLW	EE_adr2
	CALL	EEPROM_WRITE	;	Write EEPROM EE 0x01 = 0x00
	RETURN

LESE_SPEED					; *****************************
; Eingangsspannung wandeln (11+n*3)
	MOVFW	speed2

	ADDWF	speed3,0

	MOVWF	speed1
	RRF 	speed1,1
	MOVFW	speed3
	MOVWF	speed2
	BCF 	INTCON,GIE
	BSF 	ADCON0,2		;	ADC starten
LESE_LOOP
	BTFSC	ADCON0,2		;	ist der ADC fertig?
	GOTO	LESE_LOOP
	MOVFW	ADRESH			;	obere 8 Bit auslesen
	MOVWF	t_speed
;	MOVWF	speed
	BCF 	STATUS,C
	RRF 	t_speed,1
;	RRF 	speed,f
	BTFSC	STATUS,Z
	BCF 	s_key,2
	BSF 	INTCON,GIE
	MOVFW	t_speed
	MOVWF	speed3
	ADDWF	speed1,1
	RRF 	speed1,0

;	MOVFW	t_speed
	XORWF	speed,1
	BTFSS	STATUS,Z
	BSF 	s_key,3
	MOVWF	speed
	RETURN

; *********************************************************
LNCV_START
	MOVLW	0xFF
	XORWF	byte9,0
	BTFSS	STATUS,Z
	GOTO	LNCV_START1
	MOVLW	0xFF
	XORWF	byteA,0
	BTFSC	STATUS,Z
	GOTO	LNCV_START2
LNCV_START1
	MOVFW	id1
	XORWF	byte9,0
	BTFSS	STATUS,Z
	GOTO	LNCV_START3
	MOVFW	id2
	XORWF	byteA,0
	BTFSS	STATUS,Z
	GOTO	LNCV_START3
LNCV_START2
	BTFSS	byteB,7
LNCV_START3
	GOTO	INT_LN_ENDE

	BSF 	s_ser,2
	MOVFW	byte0
	MOVWF	lncvs
	MOVFW	byte1
	MOVWF	lncvd

LNCV_READ
	MOVFW	byte7
	MOVWF	lnim3			;	0 Adresse?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ0
	DECF	lnim3			;	1 Lok-Adresse?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ1
	DECF	lnim3			;	2 Analog/Digital?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ2
	DECF	lnim3			;	3 Wechsestrom/Gleichstrom?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ3
	DECF	lnim3			;	4 Zero Wartezeit?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ4
	DECF	lnim3			;	5 Sperre Dispatch?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ5
	DECF	lnim3			;	6 Version?
	BTFSC	STATUS,Z
	GOTO	LNCV_READ6
	GOTO	INT_LN_ENDE
LNCV_READ0
	MOVLW	0x00
	MOVWF	lnim3
	MOVFW	id1
	MOVWF	lnim5
	MOVFW	id2
	MOVWF	lnim6
	GOTO	LNCV_READ_A
LNCV_READ1
	MOVLW	0x01
	MOVWF	lnim3
	MOVFW	adr_
	MOVWF	lnim5
	MOVFW	adr2
	MOVWF	lnim6
	GOTO	LNCV_READ_A
LNCV_READ2
	MOVLW	0x02
	MOVWF	lnim3
	MOVLW	0x00
	MOVWF	lnim6
	BTFSC	flags,5
	MOVLW	0x01
	MOVWF	lnim5
	GOTO	LNCV_READ_A
LNCV_READ3
	MOVLW	0x03
	MOVWF	lnim3
	MOVLW	0x00
	MOVWF	lnim6
	BTFSC	flags,6
	MOVLW	0x01
	MOVWF	lnim5
	GOTO	LNCV_READ_A
LNCV_READ4
	MOVLW	0x04
	MOVWF	lnim3
	MOVFW	z_wait
	MOVWF	lnim5
	MOVLW	0x00
	MOVWF	lnim6
	GOTO	LNCV_READ_A
LNCV_READ5
	MOVLW	0x05
	MOVWF	lnim3
	MOVLW	0x00
	MOVWF	lnim6
	BTFSC	flags,4
	MOVLW	0x01
	MOVWF	lnim5
	GOTO	LNCV_READ_A
LNCV_READ6
	MOVLW	0x06
	MOVWF	lnim3
	MOVFW	versionl
	MOVWF	lnim5
	MOVFW	versionh
	MOVWF	lnim6
;	GOTO	LNCV_READ_A

LNCV_READ_A
	CALL	SEND_PEER_XFER
	GOTO	INT_LN_ENDE

LNCV_WRITE
	MOVFW	byte7
	MOVWF	lnim3			;	0 Adresse?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE0
	DECF	lnim3			;	1 Lok-Adresse?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE1
	DECF	lnim3			;	2 Analog/Digital?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE2
	DECF	lnim3			;	3 Wechsestrom/Gleichstrom?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE3
	DECF	lnim3			;	4 Zero Wartezeit?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE4
	DECF	lnim3			;	5 Sperre Dispatch?
	BTFSC	STATUS,Z
	GOTO	LNCV_WRITE5
	MOVLW	0x00
	GOTO	LNCV_WRITE_1
LNCV_WRITE0					;	Adresse
	MOVFW	byte9
	MOVWF	ee_byte
	MOVWF	id1
	MOVLW	EE_idL
	CALL	EEPROM_WRITE
	MOVFW	byteA
	MOVWF	ee_byte
	MOVWF	id2
	MOVLW	EE_idH
	CALL	EEPROM_WRITE
	GOTO	LNCV_WRITE_0
LNCV_WRITE1					;	Lokadresse
	MOVFW	byte9
	MOVWF	ee_byte
	MOVWF	adr_
	MOVLW	EE_adr_
	CALL	EEPROM_WRITE
	MOVFW	byteA
	MOVWF	ee_byte
	MOVWF	adr2
	MOVLW	EE_adr2
	CALL	EEPROM_WRITE
	GOTO	LNCV_WRITE_0
LNCV_WRITE2					;	Analog/Digital
	CLRF	ee_byte
	BCF 	flags,5
	MOVFW	byte9
	BTFSS	STATUS,Z
	BSF 	flags,5
	BTFSC	flags,5
	BSF 	ee_byte,0
	MOVWF	ee_byte
	MOVLW	EE_analog
	CALL	EEPROM_WRITE
	GOTO	LNCV_WRITE_0
LNCV_WRITE3					;	Wechselstrom
	CLRF	ee_byte
	BCF 	flags,6
	MOVFW	byte9
	BTFSS	STATUS,Z
	BSF 	flags,6
	BTFSC	flags,6
	BSF 	ee_byte,0
	MOVWF	ee_byte
	MOVLW	EE_wstrom
	CALL	EEPROM_WRITE
	GOTO	LNCV_WRITE_0
LNCV_WRITE4					;	Zero_Wait
	MOVFW	byte9
	MOVWF	ee_byte
	MOVWF	z_wait
	MOVLW	EE_z_wait
	CALL	EEPROM_WRITE
	GOTO	LNCV_WRITE_0
LNCV_WRITE5					;	Lock Lokadresse
	CLRF	ee_byte
	BCF 	flags,4
	MOVFW	byte9
	BTFSS	STATUS,Z
	BSF 	flags,4
	BTFSC	flags,4
	BSF 	ee_byte,0
	MOVWF	ee_byte
	MOVLW	EE_lock
	CALL	EEPROM_WRITE
;	GOTO	LNCV_WRITE_0
LNCV_WRITE_0
	MOVLW	0x7F
LNCV_WRITE_1
	MOVWF	lack2
	MOVLW	0x6D
	MOVWF	lack1
	CALL	SEND_LACK2
;	CALL	SEND_TEST
	GOTO	INT_LN_ENDE

LNCV_END
;	GOTO	INT_LN_ENDE
	GOTO	START
; *********************************************************
EEPROM_READ					;	read EEPROM
	BCF 	STATUS,RP0		;	Adr in w
	BSF 	STATUS,RP1		;	Rckgabe Daten in w
	MOVWF	EEADR
	BSF 	STATUS,RP0
;	BSF 	STATUS,RP1
	BSF 	EECON1,RD
	BCF 	STATUS,RP0
;	BCF 	STATUS,RP1
	MOVFW	EEDATA
	BCF 	STATUS,RP0
	BCF 	STATUS,RP1
	RETURN

EEPROM_WRITE				;	write EEPROM
	BCF 	STATUS,RP0		;	Adr in w
	BSF 	STATUS,RP1		;	Daten in ee_byte
	MOVWF	EEADR
	MOVFW	ee_byte
	BSF 	STATUS,RP0
;	BSF 	STATUS,RP1
	BSF 	EECON1,RD
	BCF 	STATUS,RP0
;	BSF 	STATUS,RP1
	XORWF	EEDATA,f
	BTFSC	STATUS,Z
	GOTO	EEPROM_WRITE2
	MOVWF	EEDATA
	BSF 	STATUS,RP0
;	BSF 	STATUS,RP1
	BCF 	INTCON,GIE
	BSF 	EECON1,WREN
	MOVLW	0x55
	MOVWF	EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF 	EECON1,WR
	BCF 	EECON1,WREN
EEPROM_WRITE1
;	BCF 	STATUS,RP0
;	BSF 	STATUS,RP1
	BTFSC	EECON1,WR
	GOTO	EEPROM_WRITE1
EEPROM_WRITE2
	BSF 	INTCON,GIE
	BCF 	STATUS,RP0
	BCF 	STATUS,RP1
	RETURN

WARTE10t_p					;	Zeitschleife
	NOP						;	2*n + 1,5/2/2,5/3 s
WARTE9t_p
	NOP
WARTE8t_p
	NOP
WARTE7t_p
	ADDLW	0xFF
	BTFSS	STATUS,Z
	GOTO	WARTE7t_p
WARTE4t
	RETURN

; EE-PROM Daten
	org 	0x2100
	DA  	0x0B			; 0x00	adr_
	DA		0x00			; 0x01	adr2
	DA  	0x00			; 0x02	speed	
	DA  	0x00			; 0x03	dirf
	DA  	0x00			; 0x04	snd
	DA		0x01			; 0x05	FRED-ID low
	DA  	0x04			; 0x06	FRED-ID High
	DA  	.029			; 0x07	Version Low
	DA		.001			; 0x08	Version High
	DA		0x0C			; 0x09	z_wait
	DA		0x00			; 0x0A	Analog
	DA		0x01			; 0x0B	Wechselstrommdus
;	DA		0x00			; 0x0C	8 Tasten
	DA		0x00			; 0x0C	Sperre Lokadresse
; bis 0x21FF

	END
; end of file
